---
title: "AI Toolkit"
enterprise: true
framework: javascript
version: "36.1.0"
---

# AI Toolkit

Easily integrate AG Grid with your own LLM, enabling end users to query and manipulate grid state via natural language.

The example below demonstrates a chat application, built using the AI Toolkit APIs and integrated with ChatGPT's `gpt-5-mini` model, that allows for manipulation of grid state via natural language.

This example does not maintain conversation state. If the LLM responds with a question, please update your initial query, instead of only answering the question.

Suggested prompts:

- "Show me all the gold medals won by the USA"
- "Sort the competitors with the youngest first"
- "Group by country and show the total number of medals won"

#### Natural Language Grid State Management

```ts
import {
  GridApi,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { callChatGPT } from "./chatgptApi";
import { gridOptions } from "./gridOptions";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

let gridApi: GridApi;

function processRequest(event?: Event) {
  event?.preventDefault();

  const inputElement = document.getElementById(
    "naturalLanguageInput",
  ) as HTMLInputElement;
  const submitButton = document.getElementById(
    "processRequest",
  ) as HTMLButtonElement;
  const outputElement = document.getElementById("aiResponse") as HTMLDivElement;
  const statusElement = document.getElementById(
    "processingStatus",
  ) as HTMLDivElement;

  const userRequest = inputElement.value.trim();

  if (!userRequest) {
    outputElement.innerHTML =
      '<p style="color: red;">Please enter a request</p>';
    outputElement.style.display = "block";
    return;
  }

  inputElement.disabled = true;
  submitButton.disabled = true;

  statusElement.innerHTML =
    '<code class="process">Processing request with ChatGPT. LLM may take up to 30s to respond. <b>⧖</b></code>';
  outputElement.innerHTML = "";

  const currentState = gridApi.getState();

  callChatGPT(userRequest, currentState, gridApi)
    .then(function (response) {
      if (response.gridState && Object.keys(response.gridState).length > 0) {
        gridApi.setState(response.gridState, response.propertiesToIgnore);
      }

      statusElement.innerHTML =
        '<code class="success">Request processed successfully! <b>✓</b></code>';
      outputElement.innerHTML = `
                <i class="prompt">Prompt</i>
                <p class="msg prompt">${userRequest}</p>
                <i class="response">Response</i>
                <p class="msg response">${response.explanation}</p>
            `;
      outputElement.style.display = "block";

      inputElement.value = "";
      inputElement.disabled = false;
      submitButton.disabled = false;
    })
    .catch(function (error) {
      statusElement.innerHTML =
        '<code class="error">Error processing request <b>✗</b></code>';
      outputElement.innerHTML = `<p>Error: ${error instanceof Error ? error.message : String(error)}</p>`;
      outputElement.style.display = "block";

      // Re-enable form on error
      inputElement.disabled = false;
      submitButton.disabled = false;
    });
}

function getCurrentState() {
  const state = gridApi.getState();
  const outputElement = document.getElementById(
    "currentState",
  ) as HTMLDivElement;
  outputElement.style.display = "block";
}

function resetGrid() {
  gridApi.setState({
    columnVisibility: { hiddenColIds: [] },
    columnPinning: { leftColIds: [], rightColIds: [] },
    sort: { sortModel: [] },
    filter: { filterModel: {} },
    rowGroup: { groupColIds: [] },
    pagination: { page: 0, pageSize: 20 },
  });

  const aiResponse = document.getElementById("aiResponse")!;
  const processingStatus = document.getElementById("processingStatus")!;
  const currentState = document.getElementById("currentState")!;

  aiResponse.innerHTML = "";
  aiResponse.style.display = "none";
  processingStatus.innerHTML = "";
  currentState.innerHTML = "";
  currentState.style.display = "none";
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

const form = document.getElementById("requestForm") as HTMLFormElement;
form.addEventListener("submit", processRequest);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).resetGrid = resetGrid;
}
```

[Live example: Natural Language Grid State Management](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/natural-language-grid-state/typescript)

## How It Works

[Structured Outputs](https://platform.openai.com/docs/guides/structured-outputs) is an LLM feature that ensures model responses adhere to a supplied [JSON Schema](https://json-schema.org/). Structured Outputs are supported by many LLMs, including ChatGPT and Gemini.

The AI Toolkit provides a `getStructuredSchema` API that generates a structured schema, based on [grid state](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/grid-state/). These outputs can be passed to an LLM, which can then generate valid responses that can be passed directly to the `setState` API method. This ensures reliable, schema-aligned instructions for updating or manipulating the grid based on natural language input.

The schema is made up of a series of "features", each representing a different aspect of the grid that can be manipulated. The following features are currently supported:

- [Filtering](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/filtering/)
- [Sorting](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/row-sorting/)
- [Aggregation](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/aggregation/)
- [Pivoting](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/pivoting/)
- [Row Grouping](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/grouping/)
- [Column Visibility](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/column-properties/#reference-display-hide)
- [Column Sizing](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/column-sizing/)

### Architecture

At a high level, the AI Toolkit works as follows:

1. **User Input Capture:** End user enters a natural language query.
2. **Prompt Construction (Client/Server):** The application gathers three elements:
   1. The user query
   2. The current grid state, via `gridApi.getState()`
   3. The structured schema of grid state, via `gridApi.getStructuredSchema()`
3. **LLM Service Request:** The complete prompt (including the structured schema) is sent to the LLM endpoint (e.g., OpenAI, Gemini).
4. **Response Processing & Validation:** The LLM returns a JSON object conforming to the schema.
5. **State Application:** The validated JSON is passed to `gridApi.setState()`.

![High Contrast Theme](https://www.ag-grid.com/archive/36.1.0/_astro/ai-toolkit-sequence-diagram.D80-HuvD.svg)

> **Note**
>
> If you wish to integrate with an LLM that does not support structured data natively, you can still use the schema to validate and parse the response from the LLM before passing it to `setState`. There are multiple libraries that can do this for you, such as [ajv](https://ajv.js.org/).

## Getting Started

To get started you'll need:

- API Key for your chosen LLM
- Existing AG Grid implementation
- Input for user queries
- Knowledge of making requests to an LLM

### Creating a Schema

The `getStructuredSchema` API returns a structured [JSON Schema](https://json-schema.org/) representation of the [Grid State](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/grid-state/) that can then be used to create a LLM compatible schema:

```ts
// Generated Structured Schema Representation of Grid State
const gridStateStructuredSchema = gridApi.getStructuredSchema();

// Create LLM compatible JSON Schema, using Grid State Structured Schema
const schema = {
    type: 'object',
    properties: {
        gridState: gridStateStructuredSchema,
        propertiesToIgnore: {
            type: 'array',
            items: {
                type: 'string',
                enum: ['aggregation', 'filter', 'sort', 'pivot', 'columnVisibility', 'columnSizing', 'rowGroup'],
            },
            description: 'List of grid state properties to ignore when applying the new state',
        },
        explanation: {
            type: 'string',
            description: 'Human-readable explanation of the changes made to the grid state',
        },
    },
    required: ['gridState', 'propertiesToIgnore', 'explanation'],
    additionalProperties: false,
};
```

The `getStructuredSchema()` API returns a narrow representation of what can be achieved using the grid's API. For example, if a column is not sortable, the schema will not include that column in the list of sortable columns. This ensures that the LLM is only able to generate valid state changes for the grid.

The `schema` contains several properties for the LLM to populate:

- `gridState` a structured output representation of grid state.
- `propertiesToIgnore` a list of grid state properties which have been unchanged, to ensure they are not overridden when updating grid state (optional, but recommended).
- `explanation` a string the LLM can use to provide human-readable context to the user about the changes that have been applied (optional, but recommended).

### Modifying State with Any LLM

To provide the LLM with sufficient context, we recommend sending the users' request, the current grid state, and the schema to the LLM:

```ts
// Get Users' Request, e.g. from Input Element
const userRequest = inputElement.value.trim();

// Get Current Grid State
const gridState = gridApi.getState();

// Send User Request & Schema to LLM
const response = await callLLM(userRequest, gridState, schema)
```

The `callLLM` function needs to be implemented in accordance with your chosen LLM. Refer to our example above for a [reference implementation](https://github.com/ag-grid/ag-grid/blob/9399cd046793a702ef0b0924f0203a5cc27b96c6/documentation/ag-grid-docs/src/content/docs/ai-toolkit/_examples/natural-language-grid-state/chatgptApi.ts#L10) using [ChatGPT's Completions API](https://platform.openai.com/docs/api-reference/chat?api-mode=chat) and the [Prompting](#prompting) section for more information on creating system prompts.

### Updating Grid State

Once the LLM has provided a response, it should be validated against your top-level schema. This is particularly important when using an LLM that does not support structured outputs.

In this example, we're using `ajv` to validate the LLMs response, before calling `setState` to update the grid:

```ts
// Extract Grid State & Properties to Ignore from LLM Response
const { newGridState, propertiesToIgnore } = response;

// Init ajv Validator with Schema
const ajv = new ajv7();
const ajvValidator = ajv.compile(schema);

// Validate LLM response w/ ajv
if (!ajvValidator(newGridState)) {
    console.error("Invalid Schema")
    return;
}

// Update Grid State with LLM Response
gridApi.setState(newGridState, propertiesToIgnore);
```

Passing `propertiesToIgnore` (the properties that are unchanged by the LLM) to `setState` ensures that these properties are not overridden after the grid state is updated.

## Excluding Features

By default, all features are enabled and included in the schema. If you wish to limit the features returned in the schema, you can do so by providing a list of feature names to the `getStructuredSchema` method.

For example, if you do not want to allow users to manipulate column visibility and sorting, you can call `getStructuredSchema` like this:

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema(
    {
         exclude: ['columnVisibility', 'sorting']
    }
);
```

## Providing Additional Context

Occasionally the LLM will need more information than can be provided by the grid alone. As such, you can pass in options for each column defining extra context.

- `description` - This provides a description of what the column contains to the LLM inline in the schema. This might include details such as the type or format of the data, to aid it when filtering or aggregating.
- `includeSetValues` - When using the Set Filter, the LLM must be provided with the allowed values for it to correctly set those it wishes to filter. However, some Set Filters contain many values which lead to a schema which is too large for your LLM to process. By default we do not include the Set Filter values, however if you set this property to true then they will be included. Refer to the [Handling Schema Size Limits](#handling-schema-size-limits) for more information.

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema({ columns: {
    sport: {
        description: "The sport the athlete won their medal in",
        includeSetValues: true
    },
    gold: {
        description: "The number of gold medals won by this athlete at this games"
    }
}});
```

> **Warning**
>
> Before including data like columns description or Set Filter values, you should be aware of the data security policy of your LLM provider.

## Prompting

The AI Toolkit does not include any prompting logic, as this will vary depending on the LLM you are using and your specific use case. This gives you the flexibility to craft prompts that are tailored to your users and the data in your grid.

In our testing we have found a few things that help get the best results from LLMs when prompting them to generate grid state changes:

- Include the current state of the grid in the prompt. This helps the LLM understand what the grid currently looks like, and what changes are being requested.
- Request the LLM to only return the grid state changes, and nothing else. This helps ensure that the response can be passed directly to `setState()`.
- You may wish to provide the LLM with a few rows of data from the grid, to help it understand the data it is working with. This is especially useful if your grid contains domain-specific data that the LLM may not be familiar with. If you have a small dataset, you can even include the entire dataset in the prompt by using `exportToCsv()`.
- If you have any domain specific knowledge or terminology that you want the LLM to be aware of, include that in the prompt as well. e.g. "In this dataset, a 'medal' refers to any of gold, silver or bronze medals won at the Olympic games".
- Including a list of available features also helps the LLM understand what it can and cannot do.

Below is an example prompt you can use as a starting point:

```ts
const prompt = `
    You are an expert data analyst working with a data grid.
    The grid contains data about Olympic athletes and their achievements.

    You should respond to user requests by generating a JSON object that
    represents their requested changes to the grid state. The response should
    include all their requested changes, along with any features that are
    already applied to the grid that they have not requested to change.

    The following is the current state of a data grid, represented as a
    JSON object. The grid contains data about Olympic athletes and their achievements.

    Current Grid State:
    ${JSON.stringify(gridApi.getState(), null, 2)}

    The grid has the following features available to manipulate:
    - Column Visibility
    - Column Sizing
    - Row Grouping
    - Sorting
    - Aggregation
    - Pivoting
    - Filtering
`
```

## Modifying the Schema

You may modify the structured schema to surgically change options or add extra features. For example, you may wish to add schema for a custom filter, or limit which columns can be hidden by the LLM:

```ts
// Generate base schema
const baseSchema = gridApi.getStructuredSchema();

// Augment with custom constraints
function applyCustomRules(schema) {
  return {
    ...schema,
    // custom schema rules...
}

const customSchema = applyCustomRules(baseSchema);
```

If you choose to do this, make sure that the result is still a valid `GridState` object before passing it to `setState`. Be aware that the JSON schema supported by LLMs is a subset of the full JSON schema spec and build your schemas accordingly.

## Handling Schema Size Limits

`includeSetValues: true` is useful when the LLM must pick from explicit allowed values (e.g., Set Filter), enabling precise filter construction. However, large cardinalities can inflate the prompt and exceed context limits.

**Recommendations**:

- Enable `includeSetValues` selectively on low-cardinality columns only.
- Consider truncating to the top N most frequent values plus an "OTHER" hint.
- Monitor total prompt size; keep within your model’s context window with a buffer for the model’s response.

## Example: AI Chat Assistant

This example demonstrates an AI chat assistant embedded within the grid's [Side Bar](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/side-bar/) as a [Custom Tool Panel](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/component-tool-panel/). The assistant maintains conversation history, enabling multi-turn interactions where users can reference previous responses and refine their requests.

Try the following sequence of prompts to see how the assistant remembers context:

1. **"Suggest 3 different ways to analyse spending patterns in this data"**
2. **"Apply suggestion 2"**
3. **"Actually, undo that and try suggestion 3 instead"**
4. **"Now add a filter to only show transactions over £100"**

#### AI Chat Assistant Embedded within Tool Panel

```ts
import {
  GridApi,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import {
  generateTransactions,
  type ITransaction,
} from "./generateTransactions";
import { gridOptions } from "./gridOptions";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

let gridApi: GridApi<ITransaction>;

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

// Generate synthetic transaction data
const data = generateTransactions({ count: 10000, seed: 42 });
gridApi.setGridOption("rowData", data);
```

[Live example: AI Chat Assistant Embedded within Tool Panel](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/tool-panel-chat-assistant/typescript)

## API

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getStructuredSchema` | `Function` |  |  | Returns the structured schema of the grid, which includes information about columns, data types, and relationships. This schema can be passed to AI services to ensure the response is of the correct format. Module: [`AiToolkitModule`](https://www.ag-grid.com/archive/36.1.0/javascript-data-grid/modules/). |


---
title: "AI Toolkit"
enterprise: true
framework: vue
version: "36.1.0"
---

# AI Toolkit

Easily integrate AG Grid with your own LLM, enabling end users to query and manipulate grid state via natural language.

The example below demonstrates a chat application, built using the AI Toolkit APIs and integrated with ChatGPT's `gpt-5-mini` model, that allows for manipulation of grid state via natural language.

This example does not maintain conversation state. If the LLM responds with a question, please update your initial query, instead of only answering the question.

Suggested prompts:

- "Show me all the gold medals won by the USA"
- "Sort the competitors with the youngest first"
- "Group by country and show the total number of medals won"

#### Natural Language Grid State Management

```ts
import { createApp, ref } from "vue";

import type { GridApi } from "ag-grid-community";
import {
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

import { callChatGPT } from "./chatgptApi";
import { type IOlympicData, gridOptions } from "./gridOptions";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const App = {
  setup() {
    const gridApi = ref<GridApi | null>(null);
    const naturalLanguageInput = ref("");
    const aiResponse = ref("");
    const processingStatus = ref("");
    const currentState = ref("");
    const isProcessing = ref(false);

    const processRequest = async (event?: Event) => {
      event?.preventDefault();

      const userRequest = naturalLanguageInput.value.trim();

      if (!userRequest) {
        aiResponse.value = '<p style="color: red;">Please enter a request</p>';
        return;
      }

      if (!gridApi.value) {
        aiResponse.value = '<p style="color: red;">Grid not initialized</p>';
        return;
      }

      isProcessing.value = true;
      processingStatus.value =
        '<code class="process">Processing request with ChatGPT <b>⧖</b></code>';
      aiResponse.value = "";

      const currentGridState = gridApi.value.getState();

      try {
        const response = await callChatGPT(
          userRequest,
          currentGridState,
          gridApi.value,
        );

        if (response.gridState && Object.keys(response.gridState).length > 0) {
          gridApi.value.setState(
            response.gridState,
            response.propertiesToIgnore,
          );
        }

        processingStatus.value =
          '<code class="success">Request processed successfully! <b>✓</b></code>';
        aiResponse.value = `
                    <i class="prompt">Prompt</i>
                    <p class="msg prompt">${userRequest}</p>
                    <i class="response">Response</i>
                    <p class="msg response">${response.explanation}</p>
                `;

        naturalLanguageInput.value = "";
      } catch (error) {
        processingStatus.value =
          '<code class="error">Error processing request <b>✗</b></code>';
        aiResponse.value = `<p>Error: ${error instanceof Error ? error.message : String(error)}</p>`;
      } finally {
        isProcessing.value = false;
      }
    };

    const getCurrentState = () => {
      if (gridApi.value) {
        const state = gridApi.value.getState();
        currentState.value = `<h4>Current Grid State:</h4><pre>${JSON.stringify(state, null, 2)}</pre>`;
      }
    };

    const resetGrid = () => {
      if (gridApi.value) {
        gridApi.value.setState({
          columnVisibility: { hiddenColIds: [] },
          columnPinning: { leftColIds: [], rightColIds: [] },
          sort: { sortModel: [] },
          filter: { filterModel: {} },
          rowGroup: { groupColIds: [] },
          pagination: { page: 0, pageSize: 20 },
        });

        aiResponse.value = "";
        processingStatus.value = "";
        currentState.value = "";
      }
    };

    const initializeGrid = () => {
      const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
      gridApi.value = createGrid(gridDiv, gridOptions);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((response) => response.json())
        .then((data: IOlympicData[]) => {
          if (gridApi.value) {
            gridApi.value.setGridOption("rowData", data);
          }
        });
    };

    return {
      naturalLanguageInput,
      aiResponse,
      processingStatus,
      currentState,
      isProcessing,
      processRequest,
      getCurrentState,
      resetGrid,
      initializeGrid,
    };
  },
  template: `
        <div class="example-wrapper">
            <div class="example-controls">
                <div class="request-container">
                    <form class="input-group" @submit.prevent="processRequest">
                        <input
                            type="text"
                            v-model="naturalLanguageInput"
                            :disabled="isProcessing"
                            placeholder="Your prompt e.g. 'hide age column'"
                        />
                        <button type="submit" :disabled="isProcessing">→</button>
                    </form>
                    <div id="processingStatus" v-html="processingStatus"></div>
                    <div>
                        <button @click="resetGrid">Reset Grid</button>
                    </div>
                </div>

                <div class="response-container">
                    <div id="aiResponse" v-if="aiResponse" v-html="aiResponse"></div>
                    <div id="currentState" v-if="currentState" v-html="currentState"></div>
                </div>
            </div>

            <div id="myGrid"></div>
        </div>
    `,
  mounted() {
    this.initializeGrid();
  },
};

createApp(App).mount("#app");
```

[Live example: Natural Language Grid State Management](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/natural-language-grid-state/vue3)

## How It Works

[Structured Outputs](https://platform.openai.com/docs/guides/structured-outputs) is an LLM feature that ensures model responses adhere to a supplied [JSON Schema](https://json-schema.org/). Structured Outputs are supported by many LLMs, including ChatGPT and Gemini.

The AI Toolkit provides a `getStructuredSchema` API that generates a structured schema, based on [grid state](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/grid-state/). These outputs can be passed to an LLM, which can then generate valid responses that can be passed directly to the `setState` API method. This ensures reliable, schema-aligned instructions for updating or manipulating the grid based on natural language input.

The schema is made up of a series of "features", each representing a different aspect of the grid that can be manipulated. The following features are currently supported:

- [Filtering](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/filtering/)
- [Sorting](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/row-sorting/)
- [Aggregation](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/aggregation/)
- [Pivoting](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/pivoting/)
- [Row Grouping](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/grouping/)
- [Column Visibility](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/column-properties/#reference-display-hide)
- [Column Sizing](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/column-sizing/)

### Architecture

At a high level, the AI Toolkit works as follows:

1. **User Input Capture:** End user enters a natural language query.
2. **Prompt Construction (Client/Server):** The application gathers three elements:
   1. The user query
   2. The current grid state, via `gridApi.getState()`
   3. The structured schema of grid state, via `gridApi.getStructuredSchema()`
3. **LLM Service Request:** The complete prompt (including the structured schema) is sent to the LLM endpoint (e.g., OpenAI, Gemini).
4. **Response Processing & Validation:** The LLM returns a JSON object conforming to the schema.
5. **State Application:** The validated JSON is passed to `gridApi.setState()`.

![High Contrast Theme](https://www.ag-grid.com/archive/36.1.0/_astro/ai-toolkit-sequence-diagram.D80-HuvD.svg)

> **Note**
>
> If you wish to integrate with an LLM that does not support structured data natively, you can still use the schema to validate and parse the response from the LLM before passing it to `setState`. There are multiple libraries that can do this for you, such as [ajv](https://ajv.js.org/).

## Getting Started

To get started you'll need:

- API Key for your chosen LLM
- Existing AG Grid implementation
- Input for user queries
- Knowledge of making requests to an LLM

### Creating a Schema

The `getStructuredSchema` API returns a structured [JSON Schema](https://json-schema.org/) representation of the [Grid State](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/grid-state/) that can then be used to create a LLM compatible schema:

```ts
// Generated Structured Schema Representation of Grid State
const gridStateStructuredSchema = gridApi.getStructuredSchema();

// Create LLM compatible JSON Schema, using Grid State Structured Schema
const schema = {
    type: 'object',
    properties: {
        gridState: gridStateStructuredSchema,
        propertiesToIgnore: {
            type: 'array',
            items: {
                type: 'string',
                enum: ['aggregation', 'filter', 'sort', 'pivot', 'columnVisibility', 'columnSizing', 'rowGroup'],
            },
            description: 'List of grid state properties to ignore when applying the new state',
        },
        explanation: {
            type: 'string',
            description: 'Human-readable explanation of the changes made to the grid state',
        },
    },
    required: ['gridState', 'propertiesToIgnore', 'explanation'],
    additionalProperties: false,
};
```

The `getStructuredSchema()` API returns a narrow representation of what can be achieved using the grid's API. For example, if a column is not sortable, the schema will not include that column in the list of sortable columns. This ensures that the LLM is only able to generate valid state changes for the grid.

The `schema` contains several properties for the LLM to populate:

- `gridState` a structured output representation of grid state.
- `propertiesToIgnore` a list of grid state properties which have been unchanged, to ensure they are not overridden when updating grid state (optional, but recommended).
- `explanation` a string the LLM can use to provide human-readable context to the user about the changes that have been applied (optional, but recommended).

### Modifying State with Any LLM

To provide the LLM with sufficient context, we recommend sending the users' request, the current grid state, and the schema to the LLM:

```ts
// Get Users' Request, e.g. from Input Element
const userRequest = inputElement.value.trim();

// Get Current Grid State
const gridState = gridApi.getState();

// Send User Request & Schema to LLM
const response = await callLLM(userRequest, gridState, schema)
```

The `callLLM` function needs to be implemented in accordance with your chosen LLM. Refer to our example above for a [reference implementation](https://github.com/ag-grid/ag-grid/blob/9399cd046793a702ef0b0924f0203a5cc27b96c6/documentation/ag-grid-docs/src/content/docs/ai-toolkit/_examples/natural-language-grid-state/chatgptApi.ts#L10) using [ChatGPT's Completions API](https://platform.openai.com/docs/api-reference/chat?api-mode=chat) and the [Prompting](#prompting) section for more information on creating system prompts.

### Updating Grid State

Once the LLM has provided a response, it should be validated against your top-level schema. This is particularly important when using an LLM that does not support structured outputs.

In this example, we're using `ajv` to validate the LLMs response, before calling `setState` to update the grid:

```ts
// Extract Grid State & Properties to Ignore from LLM Response
const { newGridState, propertiesToIgnore } = response;

// Init ajv Validator with Schema
const ajv = new ajv7();
const ajvValidator = ajv.compile(schema);

// Validate LLM response w/ ajv
if (!ajvValidator(newGridState)) {
    console.error("Invalid Schema")
    return;
}

// Update Grid State with LLM Response
gridApi.setState(newGridState, propertiesToIgnore);
```

Passing `propertiesToIgnore` (the properties that are unchanged by the LLM) to `setState` ensures that these properties are not overridden after the grid state is updated.

## Excluding Features

By default, all features are enabled and included in the schema. If you wish to limit the features returned in the schema, you can do so by providing a list of feature names to the `getStructuredSchema` method.

For example, if you do not want to allow users to manipulate column visibility and sorting, you can call `getStructuredSchema` like this:

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema(
    {
         exclude: ['columnVisibility', 'sorting']
    }
);
```

## Providing Additional Context

Occasionally the LLM will need more information than can be provided by the grid alone. As such, you can pass in options for each column defining extra context.

- `description` - This provides a description of what the column contains to the LLM inline in the schema. This might include details such as the type or format of the data, to aid it when filtering or aggregating.
- `includeSetValues` - When using the Set Filter, the LLM must be provided with the allowed values for it to correctly set those it wishes to filter. However, some Set Filters contain many values which lead to a schema which is too large for your LLM to process. By default we do not include the Set Filter values, however if you set this property to true then they will be included. Refer to the [Handling Schema Size Limits](#handling-schema-size-limits) for more information.

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema({ columns: {
    sport: {
        description: "The sport the athlete won their medal in",
        includeSetValues: true
    },
    gold: {
        description: "The number of gold medals won by this athlete at this games"
    }
}});
```

> **Warning**
>
> Before including data like columns description or Set Filter values, you should be aware of the data security policy of your LLM provider.

## Prompting

The AI Toolkit does not include any prompting logic, as this will vary depending on the LLM you are using and your specific use case. This gives you the flexibility to craft prompts that are tailored to your users and the data in your grid.

In our testing we have found a few things that help get the best results from LLMs when prompting them to generate grid state changes:

- Include the current state of the grid in the prompt. This helps the LLM understand what the grid currently looks like, and what changes are being requested.
- Request the LLM to only return the grid state changes, and nothing else. This helps ensure that the response can be passed directly to `setState()`.
- You may wish to provide the LLM with a few rows of data from the grid, to help it understand the data it is working with. This is especially useful if your grid contains domain-specific data that the LLM may not be familiar with. If you have a small dataset, you can even include the entire dataset in the prompt by using `exportToCsv()`.
- If you have any domain specific knowledge or terminology that you want the LLM to be aware of, include that in the prompt as well. e.g. "In this dataset, a 'medal' refers to any of gold, silver or bronze medals won at the Olympic games".
- Including a list of available features also helps the LLM understand what it can and cannot do.

Below is an example prompt you can use as a starting point:

```ts
const prompt = `
    You are an expert data analyst working with a data grid.
    The grid contains data about Olympic athletes and their achievements.

    You should respond to user requests by generating a JSON object that
    represents their requested changes to the grid state. The response should
    include all their requested changes, along with any features that are
    already applied to the grid that they have not requested to change.

    The following is the current state of a data grid, represented as a
    JSON object. The grid contains data about Olympic athletes and their achievements.

    Current Grid State:
    ${JSON.stringify(gridApi.getState(), null, 2)}

    The grid has the following features available to manipulate:
    - Column Visibility
    - Column Sizing
    - Row Grouping
    - Sorting
    - Aggregation
    - Pivoting
    - Filtering
`
```

## Modifying the Schema

You may modify the structured schema to surgically change options or add extra features. For example, you may wish to add schema for a custom filter, or limit which columns can be hidden by the LLM:

```ts
// Generate base schema
const baseSchema = gridApi.getStructuredSchema();

// Augment with custom constraints
function applyCustomRules(schema) {
  return {
    ...schema,
    // custom schema rules...
}

const customSchema = applyCustomRules(baseSchema);
```

If you choose to do this, make sure that the result is still a valid `GridState` object before passing it to `setState`. Be aware that the JSON schema supported by LLMs is a subset of the full JSON schema spec and build your schemas accordingly.

## Handling Schema Size Limits

`includeSetValues: true` is useful when the LLM must pick from explicit allowed values (e.g., Set Filter), enabling precise filter construction. However, large cardinalities can inflate the prompt and exceed context limits.

**Recommendations**:

- Enable `includeSetValues` selectively on low-cardinality columns only.
- Consider truncating to the top N most frequent values plus an "OTHER" hint.
- Monitor total prompt size; keep within your model’s context window with a buffer for the model’s response.

## Example: AI Chat Assistant

This example demonstrates an AI chat assistant embedded within the grid's [Side Bar](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/side-bar/) as a [Custom Tool Panel](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/component-tool-panel/). The assistant maintains conversation history, enabling multi-turn interactions where users can reference previous responses and refine their requests.

Try the following sequence of prompts to see how the assistant remembers context:

1. **"Suggest 3 different ways to analyse spending patterns in this data"**
2. **"Apply suggestion 2"**
3. **"Actually, undo that and try suggestion 3 instead"**
4. **"Now add a filter to only show transactions over £100"**

#### AI Chat Assistant Embedded within Tool Panel

```ts
import { createApp, ref } from "vue";

import { ModuleRegistry, enableDevValidations } from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import { ITransaction, generateTransactions } from "./generateTransactions";
import { gridOptions } from "./gridOptions";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const App = {
  components: {
    AgGridVue,
  },
  setup() {
    // Generate synthetic transaction data
    const rowData = ref<ITransaction[]>(
      generateTransactions({ count: 10000, seed: 42 }),
    );

    return {
      rowData,
      gridOptions: gridOptions,
    };
  },
  template: `
        <div style="width: 100%; height: 100%;">
            <ag-grid-vue
                style="width: 100%; height: 100%;"
                :rowData="rowData"
                :gridOptions="gridOptions"
            />
        </div>
    `,
};

createApp(App).mount("#app");
```

[Live example: AI Chat Assistant Embedded within Tool Panel](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/tool-panel-chat-assistant/vue3)

## API

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getStructuredSchema` | `Function` |  |  | Returns the structured schema of the grid, which includes information about columns, data types, and relationships. This schema can be passed to AI services to ensure the response is of the correct format. Module: [`AiToolkitModule`](https://www.ag-grid.com/archive/36.1.0/vue-data-grid/modules/). |


---
title: "AI Toolkit"
enterprise: true
framework: angular
version: "36.1.0"
---

# AI Toolkit

Easily integrate AG Grid with your own LLM, enabling end users to query and manipulate grid state via natural language.

The example below demonstrates a chat application, built using the AI Toolkit APIs and integrated with ChatGPT's `gpt-5-mini` model, that allows for manipulation of grid state via natural language.

This example does not maintain conversation state. If the LLM responds with a question, please update your initial query, instead of only answering the question.

Suggested prompts:

- "Show me all the gold medals won by the USA"
- "Sort the competitors with the youngest first"
- "Group by country and show the total number of medals won"

#### Natural Language Grid State Management

```ts
import { CommonModule } from "@angular/common";
import { HttpClient } from "@angular/common/http";
import { Component, OnDestroy, OnInit, ViewChild, signal } from "@angular/core";
import { FormsModule } from "@angular/forms";

import { AgGridAngular } from "ag-grid-angular";
import { ModuleRegistry, enableDevValidations } from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

import { callChatGPT } from "./chatgptApi";
import { IOlympicData, gridOptions } from "./gridOptions";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

interface ChatMessage {
  prompt: string;
  response: string;
}

interface ProcessingState {
  isProcessing: boolean;
  status: "idle" | "processing" | "success" | "error";
  message: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [CommonModule, FormsModule, AgGridAngular],
  template: `
    <div class="example-wrapper">
      <div class="example-controls">
        <div class="request-container">
          <form class="input-group" (ngSubmit)="processRequest($event)">
            <input
              type="text"
              [ngModel]="naturalLanguageInput()"
              (ngModelChange)="naturalLanguageInput.set($event)"
              [disabled]="processingState().isProcessing"
              placeholder="Your prompt e.g. hide age column"
              name="naturalLanguageInput"
            />
            <button type="submit" [disabled]="processingState().isProcessing">
              →
            </button>
          </form>

          <div id="processingStatus" *ngIf="processingState().message">
            <code
              [class.process]="processingState().status === 'processing'"
              [class.success]="processingState().status === 'success'"
              [class.error]="processingState().status === 'error'"
            >
              {{ processingState().message }}
              <b *ngIf="processingState().status === 'processing'">⧖</b>
              <b *ngIf="processingState().status === 'success'">✓</b>
              <b *ngIf="processingState().status === 'error'">✗</b>
            </code>
          </div>

          <div>
            <button (click)="resetGrid()">Reset Grid</button>
          </div>
        </div>

        <div class="response-container">
          <div id="aiResponse" *ngIf="chatMessage()">
            <i class="prompt">Prompt</i>
            <p class="msg prompt">{{ chatMessage()?.prompt }}</p>
            <i class="response">Response</i>
            <p class="msg response">{{ chatMessage()?.response }}</p>
          </div>
        </div>
      </div>

      <ag-grid-angular
        #gridRef
        style="flex: 1;"
        [columnDefs]="columnDefs"
        [rowData]="rowData()"
        [gridOptions]="gridOptions"
      />
    </div>
  `,
})
export class AppComponent implements OnInit, OnDestroy {
  @ViewChild("gridRef") gridRef!: AgGridAngular;

  columnDefs = gridOptions.columnDefs;
  rowData = signal<IOlympicData[]>([]);
  gridOptions = gridOptions;

  naturalLanguageInput = signal("");
  chatMessage = signal<ChatMessage | null>(null);
  currentState = signal("");
  processingState = signal<ProcessingState>({
    isProcessing: false,
    status: "idle",
    message: "",
  });

  constructor(private http: HttpClient) {}

  ngOnInit() {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData.set(data);
      });
  }

  ngOnDestroy() {
    // AgGridAngular handles cleanup automatically
  }

  async processRequest(event?: Event) {
    event?.preventDefault();

    const userRequest = this.naturalLanguageInput().trim();

    if (!userRequest) {
      this.processingState.set({
        isProcessing: false,
        status: "error",
        message: "Please enter a request",
      });
      return;
    }

    if (!this.gridRef?.api) {
      this.processingState.set({
        isProcessing: false,
        status: "error",
        message: "Grid not initialized",
      });
      return;
    }

    this.processingState.set({
      isProcessing: true,
      status: "processing",
      message: "Processing request with ChatGPT",
    });
    this.chatMessage.set(null);

    const currentGridState = this.gridRef.api.getState();

    try {
      const response = await callChatGPT(
        userRequest,
        currentGridState,
        this.gridRef.api,
      );

      if (response.gridState && Object.keys(response.gridState).length > 0) {
        this.gridRef.api.setState(
          response.gridState,
          response.propertiesToIgnore,
        );
      }

      this.processingState.set({
        isProcessing: false,
        status: "success",
        message: "Request processed successfully!",
      });

      this.chatMessage.set({
        prompt: userRequest,
        response: response.explanation,
      });

      this.naturalLanguageInput.set("");
    } catch (error) {
      this.processingState.set({
        isProcessing: false,
        status: "error",
        message: `Error: ${error instanceof Error ? error.message : String(error)}`,
      });
    }
  }

  getCurrentState() {
    if (this.gridRef?.api) {
      const state = this.gridRef.api.getState();
      this.currentState.set(JSON.stringify(state, null, 2));
    }
  }

  resetGrid() {
    if (this.gridRef?.api) {
      this.gridRef.api.setState({
        columnVisibility: { hiddenColIds: [] },
        columnPinning: { leftColIds: [], rightColIds: [] },
        sort: { sortModel: [] },
        filter: { filterModel: {} },
        rowGroup: { groupColIds: [] },
        pagination: { page: 0, pageSize: 20 },
      });

      this.chatMessage.set(null);
      this.processingState.set({
        isProcessing: false,
        status: "idle",
        message: "",
      });
      this.currentState.set("");
    }
  }
}
```

[Live example: Natural Language Grid State Management](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/natural-language-grid-state/angular)

## How It Works

[Structured Outputs](https://platform.openai.com/docs/guides/structured-outputs) is an LLM feature that ensures model responses adhere to a supplied [JSON Schema](https://json-schema.org/). Structured Outputs are supported by many LLMs, including ChatGPT and Gemini.

The AI Toolkit provides a `getStructuredSchema` API that generates a structured schema, based on [grid state](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/grid-state/). These outputs can be passed to an LLM, which can then generate valid responses that can be passed directly to the `setState` API method. This ensures reliable, schema-aligned instructions for updating or manipulating the grid based on natural language input.

The schema is made up of a series of "features", each representing a different aspect of the grid that can be manipulated. The following features are currently supported:

- [Filtering](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/filtering/)
- [Sorting](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/row-sorting/)
- [Aggregation](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/aggregation/)
- [Pivoting](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/pivoting/)
- [Row Grouping](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/grouping/)
- [Column Visibility](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/column-properties/#reference-display-hide)
- [Column Sizing](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/column-sizing/)

### Architecture

At a high level, the AI Toolkit works as follows:

1. **User Input Capture:** End user enters a natural language query.
2. **Prompt Construction (Client/Server):** The application gathers three elements:
   1. The user query
   2. The current grid state, via `gridApi.getState()`
   3. The structured schema of grid state, via `gridApi.getStructuredSchema()`
3. **LLM Service Request:** The complete prompt (including the structured schema) is sent to the LLM endpoint (e.g., OpenAI, Gemini).
4. **Response Processing & Validation:** The LLM returns a JSON object conforming to the schema.
5. **State Application:** The validated JSON is passed to `gridApi.setState()`.

![High Contrast Theme](https://www.ag-grid.com/archive/36.1.0/_astro/ai-toolkit-sequence-diagram.D80-HuvD.svg)

> **Note**
>
> If you wish to integrate with an LLM that does not support structured data natively, you can still use the schema to validate and parse the response from the LLM before passing it to `setState`. There are multiple libraries that can do this for you, such as [ajv](https://ajv.js.org/).

## Getting Started

To get started you'll need:

- API Key for your chosen LLM
- Existing AG Grid implementation
- Input for user queries
- Knowledge of making requests to an LLM

### Creating a Schema

The `getStructuredSchema` API returns a structured [JSON Schema](https://json-schema.org/) representation of the [Grid State](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/grid-state/) that can then be used to create a LLM compatible schema:

```ts
// Generated Structured Schema Representation of Grid State
const gridStateStructuredSchema = gridApi.getStructuredSchema();

// Create LLM compatible JSON Schema, using Grid State Structured Schema
const schema = {
    type: 'object',
    properties: {
        gridState: gridStateStructuredSchema,
        propertiesToIgnore: {
            type: 'array',
            items: {
                type: 'string',
                enum: ['aggregation', 'filter', 'sort', 'pivot', 'columnVisibility', 'columnSizing', 'rowGroup'],
            },
            description: 'List of grid state properties to ignore when applying the new state',
        },
        explanation: {
            type: 'string',
            description: 'Human-readable explanation of the changes made to the grid state',
        },
    },
    required: ['gridState', 'propertiesToIgnore', 'explanation'],
    additionalProperties: false,
};
```

The `getStructuredSchema()` API returns a narrow representation of what can be achieved using the grid's API. For example, if a column is not sortable, the schema will not include that column in the list of sortable columns. This ensures that the LLM is only able to generate valid state changes for the grid.

The `schema` contains several properties for the LLM to populate:

- `gridState` a structured output representation of grid state.
- `propertiesToIgnore` a list of grid state properties which have been unchanged, to ensure they are not overridden when updating grid state (optional, but recommended).
- `explanation` a string the LLM can use to provide human-readable context to the user about the changes that have been applied (optional, but recommended).

### Modifying State with Any LLM

To provide the LLM with sufficient context, we recommend sending the users' request, the current grid state, and the schema to the LLM:

```ts
// Get Users' Request, e.g. from Input Element
const userRequest = inputElement.value.trim();

// Get Current Grid State
const gridState = gridApi.getState();

// Send User Request & Schema to LLM
const response = await callLLM(userRequest, gridState, schema)
```

The `callLLM` function needs to be implemented in accordance with your chosen LLM. Refer to our example above for a [reference implementation](https://github.com/ag-grid/ag-grid/blob/9399cd046793a702ef0b0924f0203a5cc27b96c6/documentation/ag-grid-docs/src/content/docs/ai-toolkit/_examples/natural-language-grid-state/chatgptApi.ts#L10) using [ChatGPT's Completions API](https://platform.openai.com/docs/api-reference/chat?api-mode=chat) and the [Prompting](#prompting) section for more information on creating system prompts.

### Updating Grid State

Once the LLM has provided a response, it should be validated against your top-level schema. This is particularly important when using an LLM that does not support structured outputs.

In this example, we're using `ajv` to validate the LLMs response, before calling `setState` to update the grid:

```ts
// Extract Grid State & Properties to Ignore from LLM Response
const { newGridState, propertiesToIgnore } = response;

// Init ajv Validator with Schema
const ajv = new ajv7();
const ajvValidator = ajv.compile(schema);

// Validate LLM response w/ ajv
if (!ajvValidator(newGridState)) {
    console.error("Invalid Schema")
    return;
}

// Update Grid State with LLM Response
gridApi.setState(newGridState, propertiesToIgnore);
```

Passing `propertiesToIgnore` (the properties that are unchanged by the LLM) to `setState` ensures that these properties are not overridden after the grid state is updated.

## Excluding Features

By default, all features are enabled and included in the schema. If you wish to limit the features returned in the schema, you can do so by providing a list of feature names to the `getStructuredSchema` method.

For example, if you do not want to allow users to manipulate column visibility and sorting, you can call `getStructuredSchema` like this:

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema(
    {
         exclude: ['columnVisibility', 'sorting']
    }
);
```

## Providing Additional Context

Occasionally the LLM will need more information than can be provided by the grid alone. As such, you can pass in options for each column defining extra context.

- `description` - This provides a description of what the column contains to the LLM inline in the schema. This might include details such as the type or format of the data, to aid it when filtering or aggregating.
- `includeSetValues` - When using the Set Filter, the LLM must be provided with the allowed values for it to correctly set those it wishes to filter. However, some Set Filters contain many values which lead to a schema which is too large for your LLM to process. By default we do not include the Set Filter values, however if you set this property to true then they will be included. Refer to the [Handling Schema Size Limits](#handling-schema-size-limits) for more information.

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema({ columns: {
    sport: {
        description: "The sport the athlete won their medal in",
        includeSetValues: true
    },
    gold: {
        description: "The number of gold medals won by this athlete at this games"
    }
}});
```

> **Warning**
>
> Before including data like columns description or Set Filter values, you should be aware of the data security policy of your LLM provider.

## Prompting

The AI Toolkit does not include any prompting logic, as this will vary depending on the LLM you are using and your specific use case. This gives you the flexibility to craft prompts that are tailored to your users and the data in your grid.

In our testing we have found a few things that help get the best results from LLMs when prompting them to generate grid state changes:

- Include the current state of the grid in the prompt. This helps the LLM understand what the grid currently looks like, and what changes are being requested.
- Request the LLM to only return the grid state changes, and nothing else. This helps ensure that the response can be passed directly to `setState()`.
- You may wish to provide the LLM with a few rows of data from the grid, to help it understand the data it is working with. This is especially useful if your grid contains domain-specific data that the LLM may not be familiar with. If you have a small dataset, you can even include the entire dataset in the prompt by using `exportToCsv()`.
- If you have any domain specific knowledge or terminology that you want the LLM to be aware of, include that in the prompt as well. e.g. "In this dataset, a 'medal' refers to any of gold, silver or bronze medals won at the Olympic games".
- Including a list of available features also helps the LLM understand what it can and cannot do.

Below is an example prompt you can use as a starting point:

```ts
const prompt = `
    You are an expert data analyst working with a data grid.
    The grid contains data about Olympic athletes and their achievements.

    You should respond to user requests by generating a JSON object that
    represents their requested changes to the grid state. The response should
    include all their requested changes, along with any features that are
    already applied to the grid that they have not requested to change.

    The following is the current state of a data grid, represented as a
    JSON object. The grid contains data about Olympic athletes and their achievements.

    Current Grid State:
    ${JSON.stringify(gridApi.getState(), null, 2)}

    The grid has the following features available to manipulate:
    - Column Visibility
    - Column Sizing
    - Row Grouping
    - Sorting
    - Aggregation
    - Pivoting
    - Filtering
`
```

## Modifying the Schema

You may modify the structured schema to surgically change options or add extra features. For example, you may wish to add schema for a custom filter, or limit which columns can be hidden by the LLM:

```ts
// Generate base schema
const baseSchema = gridApi.getStructuredSchema();

// Augment with custom constraints
function applyCustomRules(schema) {
  return {
    ...schema,
    // custom schema rules...
}

const customSchema = applyCustomRules(baseSchema);
```

If you choose to do this, make sure that the result is still a valid `GridState` object before passing it to `setState`. Be aware that the JSON schema supported by LLMs is a subset of the full JSON schema spec and build your schemas accordingly.

## Handling Schema Size Limits

`includeSetValues: true` is useful when the LLM must pick from explicit allowed values (e.g., Set Filter), enabling precise filter construction. However, large cardinalities can inflate the prompt and exceed context limits.

**Recommendations**:

- Enable `includeSetValues` selectively on low-cardinality columns only.
- Consider truncating to the top N most frequent values plus an "OTHER" hint.
- Monitor total prompt size; keep within your model’s context window with a buffer for the model’s response.

## Example: AI Chat Assistant

This example demonstrates an AI chat assistant embedded within the grid's [Side Bar](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/side-bar/) as a [Custom Tool Panel](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/component-tool-panel/). The assistant maintains conversation history, enabling multi-turn interactions where users can reference previous responses and refine their requests.

Try the following sequence of prompts to see how the assistant remembers context:

1. **"Suggest 3 different ways to analyse spending patterns in this data"**
2. **"Apply suggestion 2"**
3. **"Actually, undo that and try suggestion 3 instead"**
4. **"Now add a filter to only show transactions over £100"**

#### AI Chat Assistant Embedded within Tool Panel

```ts
import { Component, OnInit, signal } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import { ModuleRegistry, enableDevValidations } from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";

import { ITransaction, generateTransactions } from "./generateTransactions";
import { gridOptions } from "./gridOptions";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `
    <div style="width: 100%; height: 100%;">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [rowData]="rowData()"
        [gridOptions]="gridOptions"
      />
    </div>
  `,
})
export class AppComponent implements OnInit {
  gridOptions = gridOptions;
  rowData = signal<ITransaction[]>([]);

  ngOnInit() {
    // Generate synthetic transaction data
    const data = generateTransactions({ count: 10000, seed: 42 });
    this.rowData.set(data);
  }
}
```

[Live example: AI Chat Assistant Embedded within Tool Panel](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/tool-panel-chat-assistant/angular)

## API

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getStructuredSchema` | `Function` |  |  | Returns the structured schema of the grid, which includes information about columns, data types, and relationships. This schema can be passed to AI services to ensure the response is of the correct format. Module: [`AiToolkitModule`](https://www.ag-grid.com/archive/36.1.0/angular-data-grid/modules/). |


---
title: "AI Toolkit"
enterprise: true
framework: react
version: "36.1.0"
---

# AI Toolkit

Easily integrate AG Grid with your own LLM, enabling end users to query and manipulate grid state via natural language.

The example below demonstrates a chat application, built using the AI Toolkit APIs and integrated with ChatGPT's `gpt-5-mini` model, that allows for manipulation of grid state via natural language.

This example does not maintain conversation state. If the LLM responds with a question, please update your initial query, instead of only answering the question.

Suggested prompts:

- "Show me all the gold medals won by the USA"
- "Sort the competitors with the youngest first"
- "Group by country and show the total number of medals won"

#### Natural Language Grid State Management

```tsx
'use client';
import React, { StrictMode, useCallback, useRef, useState } from "react";
import { createRoot } from "react-dom/client";

import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { callChatGPT } from "./chatgptApi";
import { type IOlympicData, gridOptions } from "./gridOptions";
import "./styles.css";
import { useFetchJson } from "./useFetchJson";

interface ChatMessage {
  prompt: string;
  response: string;
}

interface ProcessingState {
  isProcessing: boolean;
  status: "idle" | "processing" | "success" | "error";
  message: string;
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const { data: rowData, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const [naturalLanguageInput, setNaturalLanguageInput] = useState("");
  const [chatMessage, setChatMessage] = useState<ChatMessage | null>(null);
  const [currentState, setCurrentState] = useState("");
  const [processingState, setProcessingState] = useState<ProcessingState>({
    isProcessing: false,
    status: "idle",
    message: "",
  });

  const processRequest = useCallback(
    async (event?: React.FormEvent) => {
      event?.preventDefault();

      const userRequest = naturalLanguageInput.trim();

      if (!userRequest) {
        setProcessingState({
          isProcessing: false,
          status: "error",
          message: "Please enter a request",
        });
        return;
      }

      if (!gridRef.current?.api) {
        setProcessingState({
          isProcessing: false,
          status: "error",
          message: "Grid not initialized",
        });
        return;
      }

      setProcessingState({
        isProcessing: true,
        status: "processing",
        message: "Processing request with ChatGPT",
      });
      setChatMessage(null);

      const currentGridState = gridRef.current.api.getState();

      try {
        const response = await callChatGPT(
          userRequest,
          currentGridState,
          gridRef.current.api,
        );

        if (response.gridState && Object.keys(response.gridState).length > 0) {
          gridRef.current.api.setState(
            response.gridState,
            response.propertiesToIgnore,
          );
        }

        setProcessingState({
          isProcessing: false,
          status: "success",
          message: "Request processed successfully!",
        });

        setChatMessage({
          prompt: userRequest,
          response: response.explanation,
        });

        setNaturalLanguageInput("");
      } catch (error) {
        setProcessingState({
          isProcessing: false,
          status: "error",
          message: `Error: ${error instanceof Error ? error.message : String(error)}`,
        });
      }
    },
    [naturalLanguageInput],
  );

  const resetGrid = useCallback(() => {
    if (gridRef.current?.api) {
      gridRef.current.api.setState({
        columnVisibility: { hiddenColIds: [] },
        columnPinning: { leftColIds: [], rightColIds: [] },
        sort: { sortModel: [] },
        filter: { filterModel: {} },
        rowGroup: { groupColIds: [] },
        pagination: { page: 0, pageSize: 20 },
      });

      setChatMessage(null);
      setProcessingState({
        isProcessing: false,
        status: "idle",
        message: "",
      });
      setCurrentState("");
    }
  }, []);

  return (
    <AgGridProvider modules={[AllEnterpriseModule]}>
      <div className="example-wrapper">
        <div className="example-controls">
          <div className="request-container">
            <form className="input-group" onSubmit={processRequest}>
              <input
                type="text"
                value={naturalLanguageInput}
                onChange={(e) => setNaturalLanguageInput(e.target.value)}
                disabled={processingState.isProcessing}
                placeholder="Your prompt e.g. 'hide age column'"
              />
              <button type="submit" disabled={processingState.isProcessing}>
                →
              </button>
            </form>

            {processingState.message && (
              <div id="processingStatus">
                <code
                  className={`
                                        ${processingState.status === "processing" ? "process" : ""}
                                        ${processingState.status === "success" ? "success" : ""}
                                        ${processingState.status === "error" ? "error" : ""}
                                    `.trim()}
                >
                  {processingState.message}
                  {processingState.status === "processing" && <b> ⧖</b>}
                  {processingState.status === "success" && <b> ✓</b>}
                  {processingState.status === "error" && <b> ✗</b>}
                </code>
              </div>
            )}

            <div>
              <button onClick={resetGrid}>Reset Grid</button>
            </div>
          </div>

          <div className="response-container">
            {chatMessage && (
              <div id="aiResponse">
                <i className="prompt">Prompt</i>
                <p className="msg prompt">{chatMessage.prompt}</p>
                <i className="response">Response</i>
                <p className="msg response">{chatMessage.response}</p>
              </div>
            )}

            {currentState && (
              <div id="currentState">
                <h4>Current Grid State:</h4>
                <pre>{currentState}</pre>
              </div>
            )}
          </div>
        </div>

        <AgGridReact
          ref={gridRef}
          columnDefs={gridOptions.columnDefs}
          rowData={rowData}
          gridOptions={gridOptions}
          loading={loading}
        />
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Natural Language Grid State Management](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/natural-language-grid-state/reactFunctionalTs)

## How It Works

[Structured Outputs](https://platform.openai.com/docs/guides/structured-outputs) is an LLM feature that ensures model responses adhere to a supplied [JSON Schema](https://json-schema.org/). Structured Outputs are supported by many LLMs, including ChatGPT and Gemini.

The AI Toolkit provides a `getStructuredSchema` API that generates a structured schema, based on [grid state](https://www.ag-grid.com/archive/36.1.0/react-data-grid/grid-state/). These outputs can be passed to an LLM, which can then generate valid responses that can be passed directly to the `setState` API method. This ensures reliable, schema-aligned instructions for updating or manipulating the grid based on natural language input.

The schema is made up of a series of "features", each representing a different aspect of the grid that can be manipulated. The following features are currently supported:

- [Filtering](https://www.ag-grid.com/archive/36.1.0/react-data-grid/filtering/)
- [Sorting](https://www.ag-grid.com/archive/36.1.0/react-data-grid/row-sorting/)
- [Aggregation](https://www.ag-grid.com/archive/36.1.0/react-data-grid/aggregation/)
- [Pivoting](https://www.ag-grid.com/archive/36.1.0/react-data-grid/pivoting/)
- [Row Grouping](https://www.ag-grid.com/archive/36.1.0/react-data-grid/grouping/)
- [Column Visibility](https://www.ag-grid.com/archive/36.1.0/react-data-grid/column-properties/#reference-display-hide)
- [Column Sizing](https://www.ag-grid.com/archive/36.1.0/react-data-grid/column-sizing/)

### Architecture

At a high level, the AI Toolkit works as follows:

1. **User Input Capture:** End user enters a natural language query.
2. **Prompt Construction (Client/Server):** The application gathers three elements:
   1. The user query
   2. The current grid state, via `gridApi.getState()`
   3. The structured schema of grid state, via `gridApi.getStructuredSchema()`
3. **LLM Service Request:** The complete prompt (including the structured schema) is sent to the LLM endpoint (e.g., OpenAI, Gemini).
4. **Response Processing & Validation:** The LLM returns a JSON object conforming to the schema.
5. **State Application:** The validated JSON is passed to `gridApi.setState()`.

![High Contrast Theme](https://www.ag-grid.com/archive/36.1.0/_astro/ai-toolkit-sequence-diagram.D80-HuvD.svg)

> **Note**
>
> If you wish to integrate with an LLM that does not support structured data natively, you can still use the schema to validate and parse the response from the LLM before passing it to `setState`. There are multiple libraries that can do this for you, such as [ajv](https://ajv.js.org/).

## Getting Started

To get started you'll need:

- API Key for your chosen LLM
- Existing AG Grid implementation
- Input for user queries
- Knowledge of making requests to an LLM

### Creating a Schema

The `getStructuredSchema` API returns a structured [JSON Schema](https://json-schema.org/) representation of the [Grid State](https://www.ag-grid.com/archive/36.1.0/react-data-grid/grid-state/) that can then be used to create a LLM compatible schema:

```ts
// Generated Structured Schema Representation of Grid State
const gridStateStructuredSchema = gridApi.getStructuredSchema();

// Create LLM compatible JSON Schema, using Grid State Structured Schema
const schema = {
    type: 'object',
    properties: {
        gridState: gridStateStructuredSchema,
        propertiesToIgnore: {
            type: 'array',
            items: {
                type: 'string',
                enum: ['aggregation', 'filter', 'sort', 'pivot', 'columnVisibility', 'columnSizing', 'rowGroup'],
            },
            description: 'List of grid state properties to ignore when applying the new state',
        },
        explanation: {
            type: 'string',
            description: 'Human-readable explanation of the changes made to the grid state',
        },
    },
    required: ['gridState', 'propertiesToIgnore', 'explanation'],
    additionalProperties: false,
};
```

The `getStructuredSchema()` API returns a narrow representation of what can be achieved using the grid's API. For example, if a column is not sortable, the schema will not include that column in the list of sortable columns. This ensures that the LLM is only able to generate valid state changes for the grid.

The `schema` contains several properties for the LLM to populate:

- `gridState` a structured output representation of grid state.
- `propertiesToIgnore` a list of grid state properties which have been unchanged, to ensure they are not overridden when updating grid state (optional, but recommended).
- `explanation` a string the LLM can use to provide human-readable context to the user about the changes that have been applied (optional, but recommended).

### Modifying State with Any LLM

To provide the LLM with sufficient context, we recommend sending the users' request, the current grid state, and the schema to the LLM:

```ts
// Get Users' Request, e.g. from Input Element
const userRequest = inputElement.value.trim();

// Get Current Grid State
const gridState = gridApi.getState();

// Send User Request & Schema to LLM
const response = await callLLM(userRequest, gridState, schema)
```

The `callLLM` function needs to be implemented in accordance with your chosen LLM. Refer to our example above for a [reference implementation](https://github.com/ag-grid/ag-grid/blob/9399cd046793a702ef0b0924f0203a5cc27b96c6/documentation/ag-grid-docs/src/content/docs/ai-toolkit/_examples/natural-language-grid-state/chatgptApi.ts#L10) using [ChatGPT's Completions API](https://platform.openai.com/docs/api-reference/chat?api-mode=chat) and the [Prompting](#prompting) section for more information on creating system prompts.

### Updating Grid State

Once the LLM has provided a response, it should be validated against your top-level schema. This is particularly important when using an LLM that does not support structured outputs.

In this example, we're using `ajv` to validate the LLMs response, before calling `setState` to update the grid:

```ts
// Extract Grid State & Properties to Ignore from LLM Response
const { newGridState, propertiesToIgnore } = response;

// Init ajv Validator with Schema
const ajv = new ajv7();
const ajvValidator = ajv.compile(schema);

// Validate LLM response w/ ajv
if (!ajvValidator(newGridState)) {
    console.error("Invalid Schema")
    return;
}

// Update Grid State with LLM Response
gridApi.setState(newGridState, propertiesToIgnore);
```

Passing `propertiesToIgnore` (the properties that are unchanged by the LLM) to `setState` ensures that these properties are not overridden after the grid state is updated.

## Excluding Features

By default, all features are enabled and included in the schema. If you wish to limit the features returned in the schema, you can do so by providing a list of feature names to the `getStructuredSchema` method.

For example, if you do not want to allow users to manipulate column visibility and sorting, you can call `getStructuredSchema` like this:

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema(
    {
         exclude: ['columnVisibility', 'sorting']
    }
);
```

## Providing Additional Context

Occasionally the LLM will need more information than can be provided by the grid alone. As such, you can pass in options for each column defining extra context.

- `description` - This provides a description of what the column contains to the LLM inline in the schema. This might include details such as the type or format of the data, to aid it when filtering or aggregating.
- `includeSetValues` - When using the Set Filter, the LLM must be provided with the allowed values for it to correctly set those it wishes to filter. However, some Set Filters contain many values which lead to a schema which is too large for your LLM to process. By default we do not include the Set Filter values, however if you set this property to true then they will be included. Refer to the [Handling Schema Size Limits](#handling-schema-size-limits) for more information.

```ts
const gridStateStructuredSchema = gridApi.getStructuredSchema({ columns: {
    sport: {
        description: "The sport the athlete won their medal in",
        includeSetValues: true
    },
    gold: {
        description: "The number of gold medals won by this athlete at this games"
    }
}});
```

> **Warning**
>
> Before including data like columns description or Set Filter values, you should be aware of the data security policy of your LLM provider.

## Prompting

The AI Toolkit does not include any prompting logic, as this will vary depending on the LLM you are using and your specific use case. This gives you the flexibility to craft prompts that are tailored to your users and the data in your grid.

In our testing we have found a few things that help get the best results from LLMs when prompting them to generate grid state changes:

- Include the current state of the grid in the prompt. This helps the LLM understand what the grid currently looks like, and what changes are being requested.
- Request the LLM to only return the grid state changes, and nothing else. This helps ensure that the response can be passed directly to `setState()`.
- You may wish to provide the LLM with a few rows of data from the grid, to help it understand the data it is working with. This is especially useful if your grid contains domain-specific data that the LLM may not be familiar with. If you have a small dataset, you can even include the entire dataset in the prompt by using `exportToCsv()`.
- If you have any domain specific knowledge or terminology that you want the LLM to be aware of, include that in the prompt as well. e.g. "In this dataset, a 'medal' refers to any of gold, silver or bronze medals won at the Olympic games".
- Including a list of available features also helps the LLM understand what it can and cannot do.

Below is an example prompt you can use as a starting point:

```ts
const prompt = `
    You are an expert data analyst working with a data grid.
    The grid contains data about Olympic athletes and their achievements.

    You should respond to user requests by generating a JSON object that
    represents their requested changes to the grid state. The response should
    include all their requested changes, along with any features that are
    already applied to the grid that they have not requested to change.

    The following is the current state of a data grid, represented as a
    JSON object. The grid contains data about Olympic athletes and their achievements.

    Current Grid State:
    ${JSON.stringify(gridApi.getState(), null, 2)}

    The grid has the following features available to manipulate:
    - Column Visibility
    - Column Sizing
    - Row Grouping
    - Sorting
    - Aggregation
    - Pivoting
    - Filtering
`
```

## Modifying the Schema

You may modify the structured schema to surgically change options or add extra features. For example, you may wish to add schema for a custom filter, or limit which columns can be hidden by the LLM:

```ts
// Generate base schema
const baseSchema = gridApi.getStructuredSchema();

// Augment with custom constraints
function applyCustomRules(schema) {
  return {
    ...schema,
    // custom schema rules...
}

const customSchema = applyCustomRules(baseSchema);
```

If you choose to do this, make sure that the result is still a valid `GridState` object before passing it to `setState`. Be aware that the JSON schema supported by LLMs is a subset of the full JSON schema spec and build your schemas accordingly.

## Handling Schema Size Limits

`includeSetValues: true` is useful when the LLM must pick from explicit allowed values (e.g., Set Filter), enabling precise filter construction. However, large cardinalities can inflate the prompt and exceed context limits.

**Recommendations**:

- Enable `includeSetValues` selectively on low-cardinality columns only.
- Consider truncating to the top N most frequent values plus an "OTHER" hint.
- Monitor total prompt size; keep within your model’s context window with a buffer for the model’s response.

## Example: AI Chat Assistant

This example demonstrates an AI chat assistant embedded within the grid's [Side Bar](https://www.ag-grid.com/archive/36.1.0/react-data-grid/side-bar/) as a [Custom Tool Panel](https://www.ag-grid.com/archive/36.1.0/react-data-grid/component-tool-panel/). The assistant maintains conversation history, enabling multi-turn interactions where users can reference previous responses and refine their requests.

Try the following sequence of prompts to see how the assistant remembers context:

1. **"Suggest 3 different ways to analyse spending patterns in this data"**
2. **"Apply suggestion 2"**
3. **"Actually, undo that and try suggestion 3 instead"**
4. **"Now add a filter to only show transactions over £100"**

#### AI Chat Assistant Embedded within Tool Panel

```tsx
'use client';
import React, { StrictMode, useMemo, useRef } from "react";
import { createRoot } from "react-dom/client";

import { ModuleRegistry, enableDevValidations } from "ag-grid-community";
import { AllEnterpriseModule } from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import {
  type ITransaction,
  generateTransactions,
} from "./generateTransactions";
import { gridOptions } from "./gridOptions";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllEnterpriseModule]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<ITransaction>>(null);

  // Generate synthetic transaction data
  const rowData = useMemo(
    () => generateTransactions({ count: 10000, seed: 42 }),
    [],
  );

  return (
    <div style={{ width: "100%", height: "100%" }}>
      <AgGridReact<ITransaction>
        ref={gridRef}
        rowData={rowData}
        gridOptions={gridOptions}
      />
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: AI Chat Assistant Embedded within Tool Panel](https://www.ag-grid.com/archive/36.1.0/examples/ai-toolkit/tool-panel-chat-assistant/reactFunctionalTs)

## API

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getStructuredSchema` | `Function` |  |  | Returns the structured schema of the grid, which includes information about columns, data types, and relationships. This schema can be passed to AI services to ensure the response is of the correct format. Module: [`AiToolkitModule`](https://www.ag-grid.com/archive/36.1.0/react-data-grid/modules/). |
